#!c:/Perl/bin/Perl

use CGI qw(:cgi-lib); 
use Win32::TieRegistry qw(:KEY_); 

if ( $ENV{'HTTP_USER_AGENT'} =~ /MSIE/ ) {
  $browser = "msie" ;
}elsif ( $ENV{'HTTP_USER_AGENT'} =~ /Mozilla/ ) {
  $browser = "netscape" ;
}else{
  print <<EOF;
Content-type: text/html

<HTML><HEAD>
<TITLE>Unknown browser</TITLE>
</HEAD>
<BODY>
<H1>Unknown browser</H1>
Sorry, I don't know how to treat a certificate request coming from
your type of browser ("$ENV{'HTTP_USER_AGENT'}").

</BODY></HTML>
EOF
}
my $exprtime;	
if (&ReadParse(*input)) {

  $unit = $input{"Unit"};
  $amount = $input{"Amount"};

  $sessionId = $input{"SessionId"};
  $emailAddress = $input{"EmailAddress"};

  if ($amount > 0) {
	$exprtime = calcExprTime($unit, $amount);
  }


  #  cf RFC1034

  if ( $sessionId !~
     /^[a-zA-Z]+([a-zA-Z0-9-]+[a-zA-Z0-9]{1}|[a-zA-Z0-9]*)-[0-9]+-[0-9]+$/ ) {

    print <<EOF;
Content-type: text/html

<HTML>
<HEAD>
<TITLE>Error: bad request identifier</TITLE>
</HEAD>
<BODY>Error: sessionID=$sessionId (bad request identifier)</BODY>
</HTML>
EOF

     exit 1;
  }

  if ( $browser eq "netscape" ) {
    $key = $input{"mykey"} ;
    $key =~ s/\n//g ;
#    $emailAddress = $input{"EmailAddress"} ;
    $commonName = $input{"CommonName"} ;
    $unit = $input{"OrganizationalUnit"};
    mkdir("c:/cygwin/tmp/cert/$sessionId",0777) ;
    chmod 0777, "c:/cygwin/tmp/cert/$sessionId" ;
    open(CERT,">c:/cygwin/tmp/cert/$sessionId/req.raw") ;
    print CERT "C=XY\n" ;
    print CERT "ST=$state\n" ;
    print CERT "L=$city\n" ;
    print CERT "O=$organization\n" ;
    print CERT "OU=$usage\n" ;
    print CERT "CN=$commonName\n" ;
    print CERT "Email=$emailAddress\n" ;
    print CERT "SPKAC=$key\n" ;
    close(CERT) ;
  }else{
    #
    #       MSIE
    #
    $req = $input{'ms_req'} ;
    mkdir("c:/cygwin/tmp/cert/$sessionId",0777) ;
    chmod 0777, "c:/cygwin/tmp/cert/$sessionId" ;
    open(CERT,">c:/cygwin/tmp/cert/$sessionId/req.raw") ;
    print CERT $req ;
    close(CERT) ;
    $req =~ s/\r//g ;
    $req =~ s/([^\n]{72,72})\n([^\n]{1,71})\n([^\n]{1,71})$/$1\n$2$3/ ;
    open(CERT,">c:/cygwin/tmp/cert/$sessionId/req") ;
    print CERT "$req\n" ;
    close(CERT) ;
  }

} else {
  print &PrintHeader;
  print "CGI error: unrecognized format!\n" ;
  exit 1 ;
}

$key = $Registry->Open("LMachine/SYSTEM/CurrentControlSet/Control/Session Manager/Environment", {Access=>KEY_ALL_ACCESS(),Delimiter=>"/"});

$certfile = `openssl rand -base64 18`;
$certfile =~ s#/#-#g;
chomp($certfile);
$key->SetValue("CERT_FILE", $certfile);

$shell = "c:/cygwin/bin/bash.exe";
$sign_script = "c:/OpenSA/Apache/conf/ssl.ca-0.1/sign-user-certs.sh";
$result = `$shell $sign_script $sessionId $certfile $exprtime`;

print <<EOF;
Location: https://bongo.stanford.edu/cgi-bin/loadCert.pl?SessionId=$sessionId&EmailAddress=$emailAddress&Expr=$exprtime

EOF

sub calcExprTime {
   my($unit, $amount) = @_;
   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime(time); 
   $year += 1900;
   if ($unit eq "Years") {  $year += $amount; }
   elsif ($unit eq "Months")  { $mon += $amount;  }
   elsif ($unit eq "Days") {  $mday += $amount;  }
   elsif ($unit eq "Hours") {  $hour += $amount; }
   elsif ($unit eq "Minutes") {  $min += $amount; }

   if ($min > 59) {
     $temp = $min;
     $min = $temp % 60;
     $hour += $temp / 60;
   }

   if ($hour > 23) {
     $temp = $hour;
     $hour = $temp % 24;
     $mday += $temp / 24;
   }

   if ($mon > 11) {
     $temp = $mon;
     $mon = $temp % 12;
     $year += $temp / 12;
   }

   $overflow = dayOverflow($mday, $mon);
   if ($overflow > 0) {
     $mday = $overflow;
     $mon++;
     if ($mon > 11) {
       $mon = $mon - 12;
       $year++;
     }
   }
   $mon++;

   my $syear, $smon, $sday, $shour, $smin;
   $syear = sprintf("%02d", $year % 100);
   $smon = constructTimeString($mon);
   $sday = constructTimeString($mday);
   $shour = constructTimeString($hour);
   $smin = constructTimeString($min);

   my $exprtime = $syear . $smon . $sday . $shour . $smin . $sec . "Z";
   return $exprtime;
}

sub dayOverflow {
   my($day, $mon) = @_;
   if ($mon == 1 && $day > 28) { ## February
	return $day - 28;
   }
   if (($mon == 3 || $mon == 5 || $mon == 8 || $mon == 10) &&
	 $day > 30) {  ## 30-day months
	return $day - 30;
   }
   if (($mon == 0 || $mon == 1 || $mon == 4 || 
	  $mon == 6 || $mon == 7 || $mon == 9 || $mon == 11) &&
	  $day > 31) {
     return $day - 31;
   }
   return 0;
} 

sub constructTimeString {
   my($unit) = @_;
   my $string;
   if ($unit < 10) {
	$string = sprintf("0%d", $unit);
   } else {
	$string = sprintf("%d", $unit);
   }
   return $string;
}

__END__

